#include <io.h>
#include <hermit.h>
#include <herrno.h>
#include <platform.h>
#include <delay.h>
#include <arch/pinmux.h>
#include <platform/pinmux.h>
#include <i2c_rcm2_gpio.h>
#include <da9063.h>

#define DA9063_SLAVE_ADDR (0x5a << 1)

static struct gpio_i2c_device i2c_pmic = { 
	xGPIO_SCL0,
	xGPIO_SDA0,
	6,
};

int da9063_request_port(void)
{
	pinmux(i2c_pmic.scl_pin, GP_GPIO, IP_FUNC1, PU_EN);
	pinmux(i2c_pmic.sda_pin, GP_GPIO, IP_FUNC1, PU_EN);

	return 0;
}

int da9063_read(u8 addr, u8 *data, size_t num)
{
	u8 head_write = DA9063_SLAVE_ADDR | I2C_WR_BIT;
	u8 head_read =  DA9063_SLAVE_ADDR | I2C_RD_BIT;

	struct i2c_msg msgs[] = {
		[0] = { &head_write, 1, I2C_M_WR },
		[1] = { &addr, 1, I2C_M_WR },
		[2] = { &head_read, 1, I2C_M_WR | I2C_REPSTART},
		[3] = { data, num, I2C_M_RD },
	};

	return i2c_xfer(&i2c_pmic, msgs, ARRAY_SIZE(msgs));
}

int da9063_write(u8 addr, u8 *data, size_t num)
{
	int ret;
	u8 head_write = DA9063_SLAVE_ADDR | I2C_WR_BIT;

	struct i2c_msg msgs[] = {
		[0] = { &head_write, 1, I2C_M_WR },
		[1] = { &addr, 1, I2C_M_WR },
		[2] = { data, num, I2C_M_WR },
	};

	ret = i2c_xfer(&i2c_pmic, msgs, ARRAY_SIZE(msgs));

	return ret;
}
